# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define section     free
%define bname     scm

Name:           maven-%{bname}
Version:        1.0
Release:        0.a4.1jpp
Epoch:          0
Summary:        Maven SCM
License:        Apache Software License 2.0
Group:          Development/Java
Vendor:         JPackage Project
Distribution:   JPackage
URL:            http://maven.apache.org/
Source0:        maven-scm-1.0-alpha-4-src.tar.gz
# svn export http://svn.apache.org/repos/asf/maven/scm/tags/maven-scm-1.0-alpha-4/
Source1:        maven-scm-1.0-api-build.xml
Source2:        maven-scm-1.0-api-project.xml
Source3:        maven-scm-1.0-manager-plexus-build.xml
Source4:        maven-scm-1.0-manager-plexus-project.xml
Source5:        maven-scm-1.0-test-build.xml
Source6:        maven-scm-1.0-test-project.xml
Source7:        maven-scm-1.0-provider-clearcase-build.xml
Source8:        maven-scm-1.0-provider-clearcase-project.xml
Source9:        maven-scm-1.0-provider-cvs-build.xml
Source10:       maven-scm-1.0-provider-cvs-project.xml
Source11:       maven-scm-1.0-provider-local-build.xml
Source12:       maven-scm-1.0-provider-local-project.xml
Source13:       maven-scm-1.0-provider-perforce-build.xml
Source14:       maven-scm-1.0-provider-perforce-project.xml
Source15:        maven-scm-1.0-provider-starteam-build.xml
Source16:        maven-scm-1.0-provider-starteam-project.xml
Source17:        maven-scm-1.0-provider-svn-build.xml
Source18:        maven-scm-1.0-provider-svn-project.xml

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
%if %{with_maven}
BuildRequires:  maven
%endif
BuildRequires:  classworlds >= 0:1.1
BuildRequires:  plexus-container-default
BuildRequires:  plexus-utils
BuildRequires:  regexp

%description
Maven's source code management system abstraction.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.


%prep
cat <<EOT


If you don''t want to build with maven, and use straight ant instead,
give rpmbuild option '--without maven'

EOT
%setup -q -n %{name}-%{version}-alpha-4
cp %{SOURCE1} maven-scm-api/build.xml
cp %{SOURCE2} maven-scm-api/project.xml
cp %{SOURCE3} maven-scm-managers/maven-scm-manager-plexus/build.xml
cp %{SOURCE4} maven-scm-managers/maven-scm-manager-plexus/project.xml
cp %{SOURCE5} maven-scm-test/build.xml
cp %{SOURCE6} maven-scm-test/project.xml
cp %{SOURCE7} maven-scm-providers/maven-scm-provider-clearcase/build.xml
cp %{SOURCE8} maven-scm-providers/maven-scm-provider-clearcase/project.xml
cp %{SOURCE9} maven-scm-providers/maven-scm-provider-cvs/build.xml
cp %{SOURCE10} maven-scm-providers/maven-scm-provider-cvs/project.xml
cp %{SOURCE11} maven-scm-providers/maven-scm-provider-local/build.xml
cp %{SOURCE12} maven-scm-providers/maven-scm-provider-local/project.xml
cp %{SOURCE13} maven-scm-providers/maven-scm-provider-perforce/build.xml
cp %{SOURCE14} maven-scm-providers/maven-scm-provider-perforce/project.xml
cp %{SOURCE15} maven-scm-providers/maven-scm-provider-starteam/build.xml
cp %{SOURCE16} maven-scm-providers/maven-scm-provider-starteam/project.xml

cp %{SOURCE17} maven-scm-providers/maven-scm-provider-svn/build.xml
cp %{SOURCE18} maven-scm-providers/maven-scm-provider-svn/project.xml

%build
%if %{with_maven}

mkdir -p .maven/repository/maven/jars
build-jar-repository .maven/repository/maven/jars \
maven-jelly-tags

mkdir -p .maven/repository/JPP/jars
build-jar-repository -s -p .maven/repository/JPP/jars \
classworlds \
plexus/container-default \
plexus/utils \
regexp \


export MAVEN_HOME_LOCAL=$(pwd)/.maven

%endif

pushd maven-scm-api
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
build-jar-repository -s -p target/lib plexus/utils
ant jar javadoc
%endif
popd

pushd maven-scm-managers/maven-scm-manager-plexus
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../../maven-scm-api/target/maven-scm-api*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default
ant jar javadoc
%endif
popd

pushd maven-scm-test
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../maven-scm-api/target/maven-scm-api*.jar target/lib
cp ../maven-scm-managers/maven-scm-manager-plexus/target/maven-scm-manager-plexus*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils
ant jar javadoc
%endif
popd

pushd maven-scm-providers/maven-scm-provider-clearcase
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../../maven-scm-api/target/maven-scm-api*.jar target/lib
cp ../../maven-scm-test/target/maven-scm-test*.jar target/lib
cp ../../maven-scm-managers/maven-scm-manager-plexus/target/maven-scm-manager-plexus*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds
ant jar javadoc
%endif
popd

pushd maven-scm-providers/maven-scm-provider-cvs
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../../maven-scm-api/target/maven-scm-api*.jar target/lib
cp ../../maven-scm-test/target/maven-scm-test*.jar target/lib
cp ../../maven-scm-managers/maven-scm-manager-plexus/target/maven-scm-manager-plexus*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds
ant jar javadoc
%endif
popd

pushd maven-scm-providers/maven-scm-provider-local
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../../maven-scm-api/target/maven-scm-api*.jar target/lib
cp ../../maven-scm-test/target/maven-scm-test*.jar target/lib
cp ../../maven-scm-managers/maven-scm-manager-plexus/target/maven-scm-manager-plexus*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds
ant jar javadoc
%endif
popd

pushd maven-scm-providers/maven-scm-provider-perforce
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../../maven-scm-api/target/maven-scm-api*.jar target/lib
cp ../../maven-scm-test/target/maven-scm-test*.jar target/lib
cp ../../maven-scm-managers/maven-scm-manager-plexus/target/maven-scm-manager-plexus*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds regexp
ant jar javadoc
%endif
popd

pushd maven-scm-providers/maven-scm-provider-starteam
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../../maven-scm-api/target/maven-scm-api*.jar target/lib
cp ../../maven-scm-test/target/maven-scm-test*.jar target/lib
cp ../../maven-scm-managers/maven-scm-manager-plexus/target/maven-scm-manager-plexus*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds
ant jar javadoc
%endif
popd

pushd maven-scm-providers/maven-scm-provider-svn
%if %{with_maven}
mkdir .svn
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../../maven-scm-api/target/maven-scm-api*.jar target/lib
cp ../../maven-scm-test/target/maven-scm-test*.jar target/lib
cp ../../maven-scm-managers/maven-scm-manager-plexus/target/maven-scm-manager-plexus*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds regexp
ant jar javadoc
%endif
popd

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 maven-scm-api/target/maven-scm-api-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/api-%{version}.jar
install -m 644 maven-scm-managers/maven-scm-manager-plexus/target/maven-scm-manager-plexus-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/manager-plexus-%{version}.jar
install -m 644 maven-scm-providers/maven-scm-provider-clearcase/target/maven-scm-provider-clearcase-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-clearcase-%{version}.jar
install -m 644 maven-scm-providers/maven-scm-provider-cvs/target/maven-scm-provider-cvs-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-cvs-%{version}.jar
install -m 644 maven-scm-providers/maven-scm-provider-local/target/maven-scm-provider-local-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-local-%{version}.jar
install -m 644 maven-scm-providers/maven-scm-provider-perforce/target/maven-scm-provider-perforce-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-perforce-%{version}.jar
install -m 644 maven-scm-providers/maven-scm-provider-starteam/target/maven-scm-provider-starteam-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-starteam-%{version}.jar
install -m 644 maven-scm-providers/maven-scm-provider-svn/target/maven-scm-provider-svn-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-svn-%{version}.jar
install -m 644 maven-scm-test/target/maven-scm-test-1.0-alpha-4.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/test-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/api
cp -pr maven-scm-api/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/api
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/manager-plexus
cp -pr maven-scm-managers/maven-scm-manager-plexus/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/manager-plexus
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-clearcase
cp -pr maven-scm-providers/maven-scm-provider-clearcase/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-clearcase
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-cvs
cp -pr maven-scm-providers/maven-scm-provider-cvs/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-cvs
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-local
cp -pr maven-scm-providers/maven-scm-provider-local/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-local
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-perforce
cp -pr maven-scm-providers/maven-scm-provider-perforce/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-perforce
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-starteam
cp -pr maven-scm-providers/maven-scm-provider-starteam/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-starteam
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-svn
cp -pr maven-scm-providers/maven-scm-provider-svn/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-svn
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/test
cp -pr maven-scm-test/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/test

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(-,root,root,-)
%{_javadir}/%{name}

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}



%changelog
* Thu Nov 07 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.a4.1jpp
- First JPackage build

